--[[ Announce ]]

if not FixR then return end

local DefaultO = {
}
local misc = {
  ["desc"] = "Announce personal Cooldown uses";
  ["alpha"] = true;
  ["GUI"] = {
  };
}

local M = FixR:NewModule("Announce", DefaultO, misc)

local spellIDs = {
  --[[
  [774] = {
    ["descON"] = "  ->Rejuvenation on";
    ["descOFF"] = "  ->Rejuvenation off";
  };
  --]]
  --Guardian Druid
  [22812] = {
    ["descON"] = "  ->Barkskin (-20%) 12s";
    ["descOFF"] = "Barkskin faded";
  };
  [61336] = {
    ["descON"] = "  ->Survival Instincts (-50%) 12s";
    ["descOFF"] = "Survival Instincts faded";
  };
  [106922] = {
    ["descON"] = "  ->Might of Ursoc (+30% HP) 20s";
    ["descOFF"] = "Might of Ursoc faded";
  };
  --Monk
  [120954] = {
    ["descON"] = "  ->Fortifying Brew (+20% HP, -20%) 20s";
    ["descOFF"] = "Fortifying Brew faded";
  };
}

local frame = nil
local frameEvents = {};
local myGUID = nil
local function initFrame()
  frame = CreateFrame("Frame")
  frame:SetScript("OnEvent", function(self, event, ...)
    frameEvents[event](self, ...); -- call one of the event functions
  end);
end

local function shout(text)
  local targetChannel = nil
  if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
    targetChannel = "INSTANCE_CHAT"
  elseif IsInRaid() then
    targetChannel = "RAID"
  elseif IsInGroup() then
    targetChannel = "PARTY"
  --elseif IsInGuild() then
  --  targetChannel = "GUILD"
  end
  if targetChannel then
    SendChatMessage(text, targetChannel)
  else
    FixR:Echo(text)
  end
end

function frameEvents:COMBAT_LOG_EVENT_UNFILTERED(...)
  local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2 = select(1, ...)
  if event == "SPELL_AURA_APPLIED" then
    if sourceGUID == myGUID then
      local spellId, spellName, spellSchool = select(12, ...) --from prefix SPELL
      local auraType = select(15, ...) --BUFF or DEBUFF
      if auraType == "BUFF" then
        local v = spellIDs[spellId]
        if v then
          shout(v["descON"])
        end
      end
    end
  elseif event == "SPELL_AURA_REMOVED" then
    if sourceGUID == myGUID then
      local spellId, spellName, spellSchool = select(12, ...)
      local auraType = select(15, ...)
      if auraType == "BUFF" then
        local v = spellIDs[spellId]
        if v then
          shout(v["descOFF"])
        end
      end
    end
  end
end

function M:Load()
  if not frame then
    initFrame()
  end
  for k, v in pairs(frameEvents) do
    frame:RegisterEvent(k); -- Register all events for which handlers have been defined
  end
  myGUID = UnitGUID("player")
end

function M:Unload()
  if frame then
    for k, v in pairs(frameEvents) do
      frame:UnregisterEvent(k); -- Unregister all events for which handlers have been defined
    end
  end
end

function M:SetOption(arg1, arg2)
end

function M:ShowOptions()
end
